/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class mtc0 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         mtc0.class,
         "mtc0",
         false,
         new ArgumentDecls()
             .add("rt", ArgumentMode.IN, REG.INFO)
             .add("cs", ArgumentMode.OUT, COP0.INFO),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final REG rt = (REG) getArgument("rt", args);
      final COP0 cs = (COP0) getArgument("cs", args);

      return new mtc0(rt, cs);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "mtc0",
          true,
          new ArgumentDecls()
              .add("rt", ArgumentMode.IN, REG.INFO)
              .add("cs", ArgumentMode.OUT, COP0.INFO),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final REG rt = (REG) getArgument("rt", args);
      final COP0 cs = (COP0) getArgument("cs", args);

      return new instruction(
        new mtc0(
          rt,
          cs
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  private final REG rt;
  private final COP0 cs;

  public mtc0(REG rt, COP0 cs) {
    assert REG.INFO.isSupported(rt);
    assert COP0.INFO.isSupported(cs);

    this.rt = rt;
    this.cs = cs;
  }

  @Override
  public String syntax() {
    return String.format("mtc0 %s, %s", rt.syntax(), cs.syntax());
  }

  @Override
  public String image() {
    return String.format("01000000100%s%s00000000000", rt.image(), cs.image());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    cs.access().store(rt.access().load());
    } finally {
    actionEnd();
    }
  }
}
